/*
 * AUTHOR: Pedro Lineu Orso                         pedro.orso@gmail.com
 *                                                            1998, 2006
 * SARG Squid Analysis Report Generator      http://sarg.sourceforge.net
 *
 * SARG donations:
 *      please look at http://sarg.sourceforge.net/donations.php
 * ---------------------------------------------------------------------
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 *
 */

#include "include/conf.h"

void htmlrel()
{
   DIR *dirp;
   FILE *fp_in, *fp_ou, *fp_ip, *fp_ip2, *fp_usr;

   struct dirent *direntp;
   long long int nnbytes=0, unbytes=0, tnbytes=0, totbytes=0, totbytes2=0;
   long long int totelap=0, totelap2=0, nnelap=0, unelap=0, tnelap=0;
   long long int incache=0, oucache=0, tnincache=0, tnoucache=0;
   char arqin[MAXLEN], arqou[MAXLEN], arqper[MAXLEN], arqip[MAXLEN];
   char nacc[20], nbytes[20], url[8192], tmsg[50], nelap[20], csort[MAXLEN];
   char period[MAXLEN], usuario[MAXLEN], wusuario[MAXLEN], u2[MAXLEN], duser[MAXLEN];
   char userbytes[20], userelap[20], userurl[1024], userhora[9], userdia[9];
   char user_ip[MAXLEN], olduserip[MAXLEN], tmp2[MAXLEN], tmp3[MAXLEN], incac[20], oucac[20];
   char denied_report[255], name2[MAXLEN];
   char *str, *mmodule;
   char warea[MAXLEN];
   char wtemp[MAXLEN], totuser[8];
   long long int tnacc=0, ttnacc=0, unacc=0;
   float perc=0, perc2=0, ouperc=0, inperc=0;
   char *s;
   int  count, s1, s2, url_limit = 40;;

   if(indexonly) return;
   if(strstr(ReportType,"users_sites") == 0) return;

   strcpy(tmp2,TempDir);
   strcat(tmp2,"/sargtmp.unsort");

   strcpy(tmp3,TempDir);
   strcat(tmp3,"/sargtmp.log");

   strcpy(arqper,dirname);
   strcat(arqper,"/period");

   if ((fp_in = fopen(arqper, "r")) == 0){
      fprintf(stderr, "SARG: (html1) %s: %s\n",text[45],arqper);
      exit(1);
   }

   fgets(period,sizeof(period),fp_in);
   fclose(fp_in);

   strcpy(arqper,dirname);
   strcat(arqper,"/general");

   if ((fp_in = fopen(arqper, "r")) == 0){
      fprintf(stderr, "SARG: (html2) %s: %s\n",text[45],arqper);
      exit(1);
   }

   while(fgets(buf,sizeof(buf),fp_in)!=NULL) {
      if(strstr(buf,"TOTAL") == 0) {
         getword(wtemp,buf,' ');
         ttnacc+=my_atoll(buf);
         getword(wtemp,buf,' ');
         getword(wtemp,buf,' ');
         totbytes+=my_atoll(wtemp);
         getword(wtemp,buf,' ');
         getword(wtemp,buf,' ');
         getword(wtemp,buf,' ');
         getword(wtemp,buf,' ');
         getword(wtemp,buf,' ');
         totelap+=my_atoll(wtemp);
      }
   }

   fclose(fp_in);

   dirp = opendir(tmp);
   while ( (direntp = readdir( dirp )) != NULL ) {
      if(strstr(direntp->d_name,".txt") == 0)
         continue;

      count=1;
      strcpy(usuario,direntp->d_name);
      wusuario[0]='\0';
   
      striptxt:
      getword(warea,usuario,'.');
      strcpy(denied_report,warea);
      strcat(wusuario,warea);
   
      if(strcmp(usuario,"txt") !=0) {
         strcat(wusuario,".");
         goto striptxt;
      }
 
      strcpy(warea,dirname);
      strcat(warea,"/");
      strcat(warea,wusuario);
      mkdir(warea,0755);

      report_day(wusuario, iprel, userip);
      greport_day(wusuario, iprel, userip);

      strcpy(usuario,wusuario);
      strcpy(arqin,tmp);
      strcat(arqin,"/");
      strcpy(arqou,dirname);
      strcat(arqou,"/");
      strcat(arqou,usuario);
      strcat(arqou,"/");
      strcat(arqou,usuario);
      strcat(arqou,".html");
      strcpy(duser,arqin);
      strcat(duser,"denied_");
      strcat(arqin,direntp->d_name);
 
      if((str=(char *) strstr(denied_report, "_")) != (char *) NULL )
         if((str=(char *) strstr(str+1, "_")) != (char *) NULL ) fixip(denied_report);

      strcat(duser,denied_report);
      strcat(duser,".html");
      if(access(duser, R_OK) != 0)
         denied_report[0]='\0';
   
      if ((fp_in = fopen(arqin, "r")) == 0){
         fprintf(stderr, "SARG: (html3) %s: %s\n",text[45],arqin);
         exit(1);
      }
   
      while(fgets(buf,sizeof(buf),fp_in)!=NULL) {
         getword(wtemp,buf,' ');
         tnacc+=my_atoll(wtemp);
         getword(wtemp,buf,' ');
         tnbytes+=my_atoll(wtemp);
         getword(wtemp,buf,' ');
         getword(wtemp,buf,' ');
         getword(wtemp,buf,' ');
         tnelap+=my_atoll(wtemp);
         getword(wtemp,buf,' ');
         tnincache+=my_atoll(wtemp);
         getword(wtemp,buf,' ');
         tnoucache+=my_atoll(wtemp);
      }

      fclose(fp_in);
   
      if ((fp_in = fopen(arqin, "r")) == 0){
         fprintf(stderr, "SARG: (html4) %s: %s\n",text[45],arqin);
         exit(1);
      }
   
      if ((fp_ou = fopen(arqou, "w")) == 0){
         fprintf(stderr, "SARG: (html5) %s: %s\n",text[45],arqou);
         exit(1);
      }
   
      fprintf(fp_ou, "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n<html>\n<head>\n  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=%s\">\n",CharSet);
      css(fp_ou);
      fputs("</head>\n",fp_ou);
      fprintf(fp_ou,"<body style=\"font-family:%s;font-size:%s;background-color:%s;background-image:url(%s)\">\n",FontFace,TitleFontSize,BgColor,BgImage);
      if(strlen(LogoImage) > 0) fprintf(fp_ou, "<center><table cellpadding=\"0\" cellspacing=\"0\">\n<tr><th class=\"logo\"><img src='%s' border=0 align=absmiddle width=%s height=%s>&nbsp;%s</th></tr>\n<tr><td height=\"5\"></td></tr>\n</table>\n",LogoImage,Width,Height,LogoText);

      if(strcmp(IndexTree,"date") == 0) show_sarg(fp_ou, "../../../..");
      else show_sarg(fp_ou, "../..");

      fprintf(fp_ou,"<center><table cellpadding=\"0\" cellspacing=\"0\">\n<tr><th class=\"title\" colspan=\"1\">%s</th></tr>\n",Title);

      strcpy(u2,usuario);
      if(userip) fixip(u2);

      if(strcmp(Ip2Name,"yes") == 0) ip2name(u2);

      if(UserTabFile[0] != '\0') {
        warea[0]=':';
	warea[1]='\0';
	strcat(warea,u2);
	strcat(warea,":");
         if((str=(char *) strstr(userfile,warea)) != (char *) NULL ) {
            z1=0;
            str2=(char *) strstr(str+1,":");
            str2++;
            bzero(name, MAXLEN);
            while(str2[z1] != ':') {
               name[z1]=str2[z1];
               z1++;
            }
         } else strcpy(name,u2);
      } else strcpy(name,u2);

      strcpy(name2,name);
      if(dotinuser && strstr(name2,"_")) {
         str2=(char *)subs(name2,"_",".");
         strcpy(name2,str2);
      }
 
      fprintf(fp_ou,"<tr><td class=\"header\" colspan=\"2\">%s:&nbsp;%s</td></tr>\n<tr><td class=\"header\" colspan=\"2\">%s:&nbsp;%s</td></tr>\n<tr><td class=\"header\" colspan=\"2\">%s:&nbsp;%s, %s</td></tr>\n<tr><th class=\"header3\" colspan=2>%s</th></tr>\n<tr><td></td></tr>\n</table></center>\n<center><table cellpadding=\"2\" cellspacing=\"1\">\n<tr><td></td></tr>\n",text[89],period,text[90],name2,text[104],UserSortField,UserSortOrder,text[32]);
      if(strlen(denied_report) > 0) fprintf(fp_ou,"<tr><td class=\"header\" colspan=11><a href=\"denied_%s.html\">%s</a></td></tr>\n",denied_report,text[116]);
   
      fprintf(fp_ou,"<tr><th></th><th class=\"header\">%s</th>",text[91]);
      if(strstr(UserReportFields,"CONNECT") != 0) fprintf(fp_ou,"<th class=\"header\">%s</th>",text[92]);
      if(strstr(UserReportFields,"BYTES") != 0) fprintf(fp_ou,"<th class=\"header\">%s</th>",text[93]);
      if(strstr(UserReportFields,"SETYB") != 0) fprintf(fp_ou,"<th class=\"header\">%%%s</th>",text[93]);
      if(strstr(UserReportFields,"IN-CACHE-OUT") != 0) fprintf(fp_ou,"<th class=\"header3\" colspan=2>%s-%s-%s</th>",text[113],text[114],text[112]);
      if(strstr(UserReportFields,"USED_TIME") != 0) fprintf(fp_ou,"<th class=\"header\">%s</th>",text[94]);
      if(strstr(UserReportFields,"MILISEC") != 0) fprintf(fp_ou,"<th class=\"header\">%s</th>",text[95]);
      if(strstr(UserReportFields,"%TIME") != 0) fprintf(fp_ou,"<th class=\"header\">%%%s</th>",text[99]);
      fputs("<tr>\n",fp_ou);
  
      if(debug) {
         if(userip) {
            strcpy(u2,usuario);
            fixip(u2);
            sprintf(msg, "%s: %s",text[61],u2);
         } else
            sprintf(msg, "%s: %s",text[61],usuario);
            debuga(msg);
      }

      fscanf(fp_in,"%s%s%s%s%s%s%s",nacc,nbytes,url,tmsg,nelap,incac,oucac);

      while(!feof(fp_in)) {
         nnbytes=my_atoll(nbytes);
         nnelap=my_atoll(nelap);
         incache=my_atoll(incac);
         oucache=my_atoll(oucac);

         if(nnbytes && tnbytes) perc=(float)nnbytes * 100 / (float)tnbytes;
         else perc=ouperc=0;

         if(nnelap && tnelap) perc2=(float)nnelap * 100 / (float)tnelap;
         else perc2=0;

         if(incache && nnbytes) inperc=(float)incache * 100 / (float)nnbytes;
         else inperc=0;

         if(oucache && nnbytes) ouperc=(float)oucache * 100 / (float)nnbytes;
         else ouperc=0;

         if(strcmp(LongUrl,"yes") != 0) {
	    for (s1=0; url[s1] && (url[s1] != '/'); s1++);
	    url[s1]= '\0';
            strcpy(urly,url);
         } else {
            strcpy(urly,url);
	    
	    for (s1=s2=strlen(urly)-1; s1>0 && (s2-s1) < url_limit && urly[s1] != '/'; s1--);
	    if (s1 == 0) mmodule = &urly[s2+1];
	    else mmodule = &urly[s1+1];

            for (s1=0; url[s1] && (url[s1] != '/'); s1++);
	    url[s1]=url[s1+1]=url[s1+2]='.';
	    url[s1+3] = '\0';
	    strcat(url,mmodule);
         }

         if(strcmp(Privacy,"yes") == 0) sprintf(httplink,"<font color=%s><href=http://%s>%s", PrivacyStringColor,PrivacyString,PrivacyString);
         else { strcpy(tmp6,"../../images");
         if(strcmp(IndexTree,"date") == 0) sprintf(tmp6,"../%s",ImageFile);
         if(strlen(BlockIt) > 0) sprintf(httplink,"<a href=\"%s%s?url=%s\"><img src=\"%s/sarg-squidguard-block.png\" border=\"0\"></a><a href=http://%s>&nbsp;%s</a>",wwwDocumentRoot,BlockIt,urly,tmp6,urly,urly);
         else sprintf(httplink,"<a href=http://%s title=\"%s\">%s</a>",urly,urly,url); }

         if(strstr(ReportType,"site_user_time_date") != 0) {
	    strcpy(ltext110,text[110]);
            if(ltext110) for(s=ltext110; *s; ++s) *s=tolower(*s);
            strcpy(siteind,urly);
            str=siteind;
            for(z1=0; z1<strlen(str); z1++) if(str[z1]=='?' || str[z1]=='-' || str[z1]=='.' || str[z1]==':' || str[z1]=='/' || str[z1]=='\\') str[z1]='_';

            sprintf(href2,"<a href=\"tt%s-%s.html\"><img src=\"%s/datetime.png\" border=\"0\" title=\"%s\"></a>",usuario,siteind,tmp6,ltext110);
         } else {
            bzero(href2, MAXLEN);
            bzero(ltext110, 50);
         } 

         fprintf(fp_ou,"<tr><td class=\"data\">%s</td><td class=\"data2\">%s</td>",href2,httplink);
         if(strstr(UserReportFields,"CONNECT") != 0) fprintf(fp_ou,"<td class=\"data\">%s</td>",fixnum(my_atoll(nacc),1));
         if(strstr(UserReportFields,"BYTES") != 0) fprintf(fp_ou,"<td class=\"data\">%s</td>",fixnum(nnbytes,1));
         if(strstr(UserReportFields,"MILISEC") != 0) fprintf(fp_ou,"<td class=\"data\">%s</td>",fixnum(nnelap,1));
         if(strstr(UserReportFields,"SETYB") != 0) fprintf(fp_ou,"<td class=\"data\">%3.2f%%</td>",perc);
         if(strstr(UserReportFields,"IN-CACHE-OUT") != 0) fprintf(fp_ou,"<td class=\"data\">%3.2f%%</td>",inperc);
         if(strstr(UserReportFields,"IN-CACHE-OUT") != 0) fprintf(fp_ou,"<td class=\"data\">%3.2f%%</td>",ouperc);
         if(strstr(UserReportFields,"USED_TIME") != 0) fprintf(fp_ou,"<td class=\"data\">%s</td>",buildtime(nnelap));
         if(strstr(UserReportFields,"%TIME") != 0) fprintf(fp_ou,"<td class=\"data\">%3.2f%%</td>",perc2);
	 if(strncmp(tmsg,"OK",2) != 0) fprintf(fp_ou,"<td class=\"data\">%s</td>",text[46]);
         fputs("<tr>\n",fp_ou);
      
         if(UserReportLimit && (count <= UserReportLimit)) count++;

         if(iprel) {
	    strcpy(arqip,tmp);
	    strcat(arqip,"/");
	    strcat(arqip,usuario);
	    strcat(arqip,".ip");
   
            if ((fp_ip = fopen(arqip, "r")) == 0){
               fprintf(stderr, "SARG: (html6) %s: %s\n",text[45],arqip);
               exit(1);
            }
   
            if ((fp_ip2 = fopen(tmp2, "a")) == 0){
               fprintf(stderr, "SARG: (html7) %s: %s\n",text[45],tmp2);
               exit(1);
            }
   
            while(fgets(buf,sizeof(buf),fp_ip)!=NULL) if(strstr(buf,url) != 0) fputs(buf,fp_ip2);
   
            fclose(fp_ip);
            fclose(fp_ip2);

            sprintf(csort,"sort -n -T %s -k 1,1 -k 5,5 -o '%s' '%s'",TempDir,tmp3,tmp2);
            system(csort);
   
            if ((fp_ip = fopen(tmp3, "r")) == 0) {
               fprintf(stderr, "SARG: (html8) %s: %s\n",text[45],tmp3);
               exit(1);
            }

            fscanf(fp_ip,"%s%s%s%s%s%s",user_ip,userurl,userdia,userhora,userbytes,userelap);
   
            strcpy(olduserip,user_ip);
            while(!feof(fp_ip)) {
               if(strcmp(user_ip,olduserip) != 0) {
                  my_lltoa(unelap,val2,0);
                  fprintf(fp_ou,"<tr><td></td><td class=\"data\">%s</td><td></td><td class=\"data\">%s</td><td></td><td></td><td></td><td class=\"data\">%s</td><td class=\"data\">%s</td></tr>\n",olduserip,fixnum(unbytes,1),buildtime(unelap),val2);
  
                  strcpy(olduserip,user_ip);
                  unacc=0;
                  unbytes=0;
                  unelap=0;
               }
   
               unbytes=unbytes+my_atoll(userbytes);
               unelap=unelap+my_atoll(userelap);

               fscanf(fp_ip,"%s%s%s%s%s%s",user_ip,userurl,userdia,userhora,userbytes,userelap);
            }

            fclose(fp_ip);

            unlink(tmp2);
            unlink(tmp3);

            my_lltoa(unelap,val3,0);
            fprintf(fp_ou,"<tr><td></td><td class=\"data\">%s</td><td></td><td class=\"data\">%s</td><td></td><td></td><td></td><td class=\"data\">%s</td><td class=\"data\">%s</font></td></tr>\n",olduserip,fixnum(unbytes,1),buildtime(unelap),val3);
         }

         unacc=0;
         unbytes=0;
         unelap=0;

         fscanf(fp_in,"%s%s%s%s%s%s%s",nacc,nbytes,url,tmsg,nelap,incac,oucac);
//         fscanf(fp_in,"%s",datestimes);
      }

      if(iprel) unlink(arqip);
      unlink(arqin);

      if(tnbytes && totbytes) perc=(float)tnbytes * 100 / (float)totbytes;
      else perc=0;
   
      if(tnelap && totelap) perc2=(float)tnelap * 100 / (float)totelap;
      else perc2=0;
   
      if(tnoucache && tnbytes) ouperc=(float)tnoucache * 100 / (float)tnbytes;
      else ouperc=0;
   
      if(tnincache && tnbytes) inperc=(float)tnincache * 100 / (float)tnbytes;
      else inperc=0;

      if(strstr(UserReportFields,"TOTAL") != 0) {
        fprintf(fp_ou,"<tr><th></th><th class=\"header\">%s</th>",text[107]);
        if(strstr(UserReportFields,"CONNECT") != 0) fprintf(fp_ou,"<th class=\"header2\">%s</th>",fixnum(tnacc,1));
        if(strstr(UserReportFields,"BYTES") != 0) fprintf(fp_ou,"<th class=\"header2\">%s</th>",fixnum(tnbytes,1));
        if(strstr(UserReportFields,"MILISEC") != 0) fprintf(fp_ou,"<th class=\"header2\">%s</th>",fixnum(tnelap,1));
        if(strstr(UserReportFields,"SETYB") != 0) fprintf(fp_ou,"<th class=\"header2\">%3.2f%%</th>",perc);
        if(strstr(UserReportFields,"IN-CACHE-OUT") != 0) fprintf(fp_ou,"<th class=\"header2\">%3.2f%%</th>",inperc);
        if(strstr(UserReportFields,"IN-CACHE-OUT") != 0) fprintf(fp_ou,"<th class=\"header2\">%3.2f%%</th>",ouperc);
        if(strstr(UserReportFields,"USED_TIME") != 0) fprintf(fp_ou,"<th class=\"header2\">%s</th>",buildtime(tnelap));
        if(strstr(UserReportFields,"%TIME") != 0) fprintf(fp_ou,"<th class=\"header2\">%3.2f%%</th>",perc2);
        fputs("<tr>\n",fp_ou);
      }

      fclose(fp_in);
  
      if(atoi(PerUserLimit) > 0) {
         if(tnbytes > (atoi(PerUserLimit)*1000000)) {
            limit_flag=0;
            if(access(PerUserLimitFile, R_OK) == 0) {
               if((fp_usr = fopen(PerUserLimitFile, "r")) == 0) {
                  fprintf(stderr, "SARG: (html9) %s: %s\n",text[45],PerUserLimitFile);
                  exit(1);
               }
               while(fgets(tmp6,sizeof(tmp6),fp_usr)!=NULL) {
                  if(strstr(tmp6,"\n") != 0)
                     tmp6[strlen(tmp6)-1]='\0';
                  if(strcmp(tmp6,u2) == 0) {
                     limit_flag=1;
                     break;
                  }
               }
               fclose(fp_usr);
            }
  
            if(!limit_flag) {
               if((fp_usr = fopen(PerUserLimitFile, "a")) == 0) {
                  fprintf(stderr, "SARG: (html10) %s: %s\n",text[45],PerUserLimitFile);
                  exit(1);
               }
               fprintf(fp_usr,"%s\n",u2);
               fclose(fp_usr);
    
               if(debug) {
                  sprintf(msg, "%s %s %s (%s MB). %s %s",text[32],u2,text[74],PerUserLimit,text[75],PerUserLimitFile);
                      debuga(msg);
               }
            }
         }
      }

      strcpy(arqper,dirname);
      strcat(arqper,"/users");
 
      if ((fp_in = fopen(arqper, "r")) == 0){
         fprintf(stderr, "SARG: (html11) %s: %s\n",text[45],arqper);
         exit(1);
      }

      fgets(totuser,8,fp_in);
      fclose(fp_in);
 
      totbytes2=totbytes/my_atoll(totuser);
      totelap2=totelap/my_atoll(totuser);
 
      if(totbytes2 && totbytes) perc = (float)totbytes2 * 100 / (float)totbytes;
      else perc=0;
   
      if(totelap2 && totelap) perc2 = (float)totelap2 * 100 / (float)totelap;
      else perc2=0;
   
      if(strstr(UserReportFields,"AVERAGE") != 0) {
        fprintf(fp_ou,"<tr><th></th><th class=\"header\">%s</th>",text[96]);
        if(strstr(UserReportFields,"CONNECT") != 0) fprintf(fp_ou,"<th class=\"header2\">%s</th>",fixnum(ttnacc/my_atoll(totuser),1));
        if(strstr(UserReportFields,"BYTES") != 0) fprintf(fp_ou,"<th class=\"header2\">%s</th>",fixnum(totbytes2,1));
        if(strstr(UserReportFields,"MILISEC") != 0) fprintf(fp_ou,"<th class=\"header2\">%s</th>",fixnum(totelap2,1));
        if(strstr(UserReportFields,"USED_TIME") != 0) fprintf(fp_ou,"<th class=\"header2\">%s</th>",buildtime(totelap2));
        if(strstr(UserReportFields,"%TIME") != 0) fprintf(fp_ou,"<th class=\"header2\">%3.2f%%</th>",perc2);
        fputs("<tr>\n",fp_ou);
      }

      tnacc=0;
      tnbytes=0;
      tnelap=0;
      tnincache=0;
      tnoucache=0;

      fputs("</center></table>\n",fp_ou);

      show_info(fp_ou);

      fputs("</body>\n</html>\n",fp_ou);

      fclose(fp_ou);

      htaccess(wusuario);
   }

   (void)rewinddir(dirp);
   (void)closedir(dirp);

   return;
}
